@echo off
TITLE ModuleCreator MAKEBIN

REM SET PATH=%PATH%;d:\TI994w\utl
SET HERE=%CD%

REM MakeBin 2.0
REM Create one big binary file from the seperate 
REM binary program files.
REM
REM ARG1: Path of the program files
REM ARG2: Filename for the big binary file
REM ARG3: Filename append for TI99/4W (_B0)
REM ARG4: STD(andard) or INV(erted) banking scheme
REM ARG5: 1st binary program name 
REM ARG6: 2nd binary program name
REM ARG7: 3rd binary program name
REM ARG8: 4th binary program name

color 1E

echo.
echo. Module Creator
echo. Start: MakeBin
echo.   Path           : %1
echo.   Module name    : %2
if not [%3]==[_B0] echo.   Append _B0     : No
if     [%3]==[_B0] echo.   Append _B0     : Yes
if     [%4]==[STD] echo.   Banking scheme : Normal
if     [%4]==[INV] echo.   Banking scheme : Inverted
echo.   First  program : %~n5
echo.   Second program : %~n6
echo.   Third  program : %~n7
echo.   Fourth program : %~n8
echo.
cd %1

if exist %2.bin    del %2.bin
if exist %2_B0.bin del %2_B0.bin

if not [%3]==[_B0] set FILENAME=%2
if     [%3]==[_B0] set FILENAME=%2_B0

REM Need at least one name
if [%5]==[] goto noname
if [%6]==[] goto 32k
if [%7]==[] goto 64k
if [%8]==[] goto 96k
goto 128k

:32k
echo. Creating 32k binary promfile %FILENAME% containing one program
copy /B .\build\%5 %FILENAME%.bin
goto end

:64k
echo. Creating 64k binary promfile %FILENAME% containing two programs
copy /B .\build\%5+.\build\%6 %FILENAME%.bin
goto end

:96k
echo. Creating 128k binary promfile %FILENAME% containing three programs
if [%4]==[STD] (
	copy /B .\build\%5+.\build\%6+.\build\%7+.\build\EMPTY.BIN %FILENAME%.bin
) else (
	copy /B .\build\EMPTY.BIN+.\build\%5+.\build\%6+.\build\%7 %FILENAME%.bin
)
goto end

:128k
echo. Creating 128k binary promfile %FILENAME% containing four programs
copy /B .\build\%5+.\build\%6+.\build\%7+.\build\%8 %FILENAME%.bin
goto end

:noname
start /WAIT wmessage -MNo programs names defined. -TMakeBin -K1 -I4
goto end

:notexist
start /WAIT wmessage -M%1\%name% program does not exist. -TMakeBin -K1 -I4
goto end

:end 
echo.
echo.
pause